<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter"
      :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true">
            <el-form-item label="模板类型" prop="type">
              <el-select v-model="queryParams.type" placeholder="请选择" clearable>
                <el-option v-for="dict in scale_type" :key="dict.value" :label="dict.label"
                  :value="dict.value"></el-option>
              </el-select>
            </el-form-item>
            <el-form-item label="模板名称" prop="name">
              <el-input v-model="queryParams.name" placeholder="请输入" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
              <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" icon="Plus" @click="handleAdd"
              v-hasPermi="['system:screeningAssessmentConfig:add']">新增量表</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Upload" @click="handleImport"
              v-hasPermi="['system:diseaseLabel:import']">快速导入JSON</el-button>
          </el-col>
          <!-- <el-col :span="1.5">
            <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate()" v-hasPermi="['system:screeningAssessmentConfig:edit']">修改</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete()" v-hasPermi="['system:screeningAssessmentConfig:remove']">删除</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['system:screeningAssessmentConfig:export']">导出</el-button>
          </el-col> -->
          <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>
      </template>

      <el-table v-loading="loading" border :data="screeningAssessmentConfigList">
        <!-- <el-table-column type="selection" width="55" align="center" />        @selection-change="handleSelectionChange" -->
        <el-table-column label="模板名称" align="center" prop="name" />
        <el-table-column label="模板类型" align="center" prop="typeName" />
        <el-table-column label="创建人" align="center" prop="createByName" />
        <el-table-column label="状态" align="center" width="100">
          <template #default="scope">
            <el-switch v-model="scope.row.status" active-value="0" inactive-value="1"
              @change="handleStatusChange(scope.row)"></el-switch>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <!-- <el-tooltip content="预览" placement="top">
              <el-button link type="primary" icon="View" @click="handleView(scope.row)">预览</el-button>
            </el-tooltip> -->
            <el-tooltip content="编辑" placement="top">
              <el-button link type="primary" icon="Edit" @click="handleUpdate(false,scope.row)"
                v-hasPermi="['system:screeningAssessmentConfig:edit']">编辑</el-button>
            </el-tooltip>
            <el-tooltip content="删除" placement="top">
              <el-button link type="danger" icon="Delete" @click="handleDelete(scope.row)"
                v-hasPermi="['system:screeningAssessmentConfig:remove']">删除</el-button>
            </el-tooltip>
            <el-tooltip content="修改结论" placement="top">
              <el-button link type="primary" icon="Edit" @click="editConclusion(scope.row)">修改结论</el-button>
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum"
        v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改筛查/评估配置对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="screeningAssessmentConfigFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="性别" prop="gender">
          <el-input v-model="form.gender" placeholder="请输入性别" />
        </el-form-item>
        <el-form-item label="年龄" prop="age">
          <el-input v-model="form.age" placeholder="请输入年龄" />
        </el-form-item>
        <el-form-item label="量表名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入量表名称" />
        </el-form-item>
        <el-form-item label="量表说明" prop="description">
          <el-input v-model="form.description" placeholder="请输入量表说明" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>


    <!--  修改结论 -->
    <el-dialog :title="dialog2.title" v-model="dialog2.visible" width="1000px" append-to-body>
      <el-row style="margin-bottom: 5px;" v-for="(item, index) in conclusionList">
        <el-col :span="4">
          <el-input v-model="item.min" placeholder="请输入" />
        </el-col>
        <el-col :span="1">
          <div style="margin-top: 5px;">分</div>
        </el-col>
        <el-col :span="1">
          <div style="margin-top: 5px;">-</div>
        </el-col>
        <el-col :span="4">
          <el-input v-model="item.max" placeholder="请输入" />
        </el-col>
        <el-col :span="1">
          <div style="margin-top: 5px;">分</div>
        </el-col>
        <el-col :span="9">
          <el-input v-model="item.text" placeholder="请输入结论" type="textarea" />
        </el-col>
        <el-col :span="1">
        </el-col>
        <el-col :span="2">
          <div class="action-buttons">
            <el-button class="icon-btn" @click="addRow()">
              <el-icon>
                <Plus />
              </el-icon>
            </el-button>
            <el-button class="icon-btn" @click="delRow(index)">
              <el-icon>
                <Delete />
              </el-icon>
            </el-button>
          </div>
        </el-col>
      </el-row>

      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitConclusionForm">确 定</el-button>
          <el-button @click="cancelConclusion">取 消</el-button>
        </div>
      </template>
    </el-dialog>


    <!-- 上传excel -->
    <el-dialog :title="dialogFile.title" v-model="dialogFile.visible" width="700px" append-to-body>
      <el-form-item label="量表类型：" required>
        <el-radio-group v-model="uploadType">
          <el-radio :label="item.label" :value="item.value" v-for="item in scale_type" :key="item.value" />
        </el-radio-group>
      </el-form-item>
      <el-upload drag :action="uploadFileUrl" :headers="headers" :file-list="fileList" accept=".json"
        ref="imageUploadRef" :on-success="handleUploadSuccess" :before-upload="handleBeforeUpload"
        :data="{type: uploadType}"
        :on-error="handleUploadError">
        <el-icon class="el-icon--upload"><upload-filled /></el-icon>
        <div class="el-upload__text">
          将文件拖到此处，或 <em>点击上传</em>
        </div>
      </el-upload>
      <div class="el-upload__tip">
        请上传 .json 标准格式文件
      </div>
    </el-dialog>
  </div>
</template>

<script setup name="ScreeningAssessmentConfig" lang="ts">
import { updateConclusion,listScreeningAssessmentConfig,changeConfigStatus, getScreeningAssessmentConfig, delScreeningAssessmentConfig, addScreeningAssessmentConfig, updateScreeningAssessmentConfig } from '@/api/system/screeningAssessmentConfig';
import { ScreeningAssessmentConfigVO, ScreeningAssessmentConfigQuery, ScreeningAssessmentConfigForm } from '@/api/system/screeningAssessmentConfig/types';
import { globalHeaders } from '@/utils/request';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const {scale_type} = toRefs<any>(proxy?.useDict('scale_type'));

const screeningAssessmentConfigList = ref<ScreeningAssessmentConfigVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const router = useRouter();
const configId = ref<string>('0');

const queryFormRef = ref<ElFormInstance>();
const screeningAssessmentConfigFormRef = ref<ElFormInstance>();

const baseUrl = import.meta.env.VITE_APP_BASE_API;
const uploadFileUrl = ref(baseUrl + '/system/screeningAssessmentConfig/importFile'); 
const headers = ref(globalHeaders());
const fileList = ref<any[]>([]);
const imageUploadRef = ref<ElUploadInstance>();
const uploadType = ref('1'); 

const dialogFile = reactive<DialogOption>({
  visible: false,
  title: '请上传'
});

/** 导出按钮操作 */
const handleImport = () => {
  dialogFile.visible = true;
  fileList.value = [];
}

// 上传失败
const handleUploadError = () => {
  proxy?.$modal.msgError('上传Excel失败');
  proxy?.$modal.closeLoading();
};

// 上传成功回调
const handleUploadSuccess = (res: any, file: UploadFile) => {
  if (res.code === 200) {
    dialogFile.visible = false;
    fileList.value = [];
    proxy?.$modal.closeLoading();
    getList();
  } else {
    proxy?.$modal.msgError(res.msg);
    proxy?.$modal.closeLoading();
  }
  fileList.value = [];
};


/** 上传前loading加载 */
const handleBeforeUpload = (file: any) => {
   const isLt = file.size / 1024 / 1024 < 10;
    if (!isLt) {
      proxy?.$modal.msgError(`上传文件大小不能超过10MB!`);
      return false;
    }       
  proxy?.$modal.loading('正在上传文件，请稍候...');
  return true;
};

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const dialog2 = reactive<DialogOption>({
  visible: false,
  title: '修改结论'
});

const initFormData: ScreeningAssessmentConfigForm = {
  configId: undefined,
  type: undefined,
  gender: undefined,
  age: undefined,
  name: undefined,
  description: undefined,
  remark: undefined,
  status: undefined,
}
const data = reactive<PageData<ScreeningAssessmentConfigForm, ScreeningAssessmentConfigQuery>>({
  form: {...initFormData},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    type: undefined,
    gender: undefined,
    age: undefined,
    name: undefined,
    description: undefined,
    status: undefined,
    params: {
    }
  },
  rules: {
    configId: [
      { required: true, message: "主键ID不能为空", trigger: "blur" }
    ],
    type: [
      { required: true, message: "量表类型不能为空", trigger: "change" }
    ],
    name: [
      { required: true, message: "量表名称不能为空", trigger: "blur" }
    ],
  }
});

const { queryParams, form, rules } = toRefs(data);

const conclusionList = ref([{ min: null, max: null, text: null }]);

const addRow = () => {
  conclusionList.value.push({ min: null, max: null, text: null });
}

const submitConclusionForm = async () => {
  let param = ref<ScreeningAssessmentConfigForm>({});
  param.value.conclusion = JSON.stringify(conclusionList.value);
  param.value.configId=configId.value;
  await updateConclusion(param.value);
  proxy?.$modal.msgSuccess("操作成功");
  dialog2.visible = false;
  getList();
}

/** 取消按钮 */
const cancelConclusion = () => {
  dialog2.visible = false;
}

const delRow = (index: number) => {
  conclusionList.value.splice(index, 1);
}

/**  编辑结论  */
const editConclusion = (row?: ScreeningAssessmentConfigVO) => {
  dialog2.visible = true;
  if(row.conclusion){
      conclusionList.value=JSON.parse(row.conclusion);  
      configId.value=row.configId.toString();     
    }else{
      conclusionList.value=[{ min: null, max: null, text: null }];      
    }
}

/** 查询筛查/评估配置列表 */
const getList = async () => {
  loading.value = true;
  const res = await listScreeningAssessmentConfig(queryParams.value);
  screeningAssessmentConfigList.value = res.rows;
  total.value = res.total;
  loading.value = false;
}

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
}

/** 表单重置 */
const reset = () => {
  form.value = {...initFormData};
  screeningAssessmentConfigFormRef.value?.resetFields();
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
}

/** 多选框选中数据 */
const handleSelectionChange = (selection: ScreeningAssessmentConfigVO[]) => {
  ids.value = selection.map(item => item.configId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
const handleAdd = () => {
  // reset();
  // dialog.visible = true;
  // dialog.title = "添加筛查/评估配置";
  router.push('/argManage/screening-assessment-page/0');
}

/** 修改按钮操作 */
const handleUpdate = async (disabled:boolean,row?: ScreeningAssessmentConfigVO) => {
  // reset();
  // const _configId = row?.configId || ids.value[0]
  // const res = await getScreeningAssessmentConfig(_configId);
  // Object.assign(form.value, res.data);
  // dialog.visible = true;
  // dialog.title = "修改筛查/评估配置";
  const _configId = row?.configId || ids.value[0]
  if(disabled){
    router.push('/argManage/screening-assessment-view/'+_configId);
  }else{
    router.push('/argManage/screening-assessment-page/'+_configId);
  } 
}

/** 修改结论 */
const handleReviseConclusion = async (row?: ScreeningAssessmentConfigVO) => { 
  const _configId = row?.configId || ids.value[0]
   
}

/** 预览 */
const handleView = async (row?: ScreeningAssessmentConfigVO) => { 
  const _configId = row?.configId || ids.value[0]
   
}



/** 提交按钮 */
const submitForm = () => {
  screeningAssessmentConfigFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.configId) {
        await updateScreeningAssessmentConfig(form.value).finally(() =>  buttonLoading.value = false);
      } else {
        await addScreeningAssessmentConfig(form.value).finally(() =>  buttonLoading.value = false);
      }
      proxy?.$modal.msgSuccess("操作成功");
      dialog.visible = false;
      await getList();
    }
  });
}

/** 删除按钮操作 */
const handleDelete = async (row?: ScreeningAssessmentConfigVO) => {
  const _configIds = row?.configId || ids.value;
  await proxy?.$modal.confirm('是否确认删除模版名称为"' + row.name + '"的数据项？').finally(() => loading.value = false);
  await delScreeningAssessmentConfig(_configIds);
  proxy?.$modal.msgSuccess("删除成功");
  await getList();
}
 


const handleStatusChange = async (row: ScreeningAssessmentConfigVO) => {
  const text = row.status === '0' ? '启用' : '停用';
  try {
    await proxy?.$modal.confirm('确认要"' + text + '""' + row.name + '"模版名称吗?');
    await changeConfigStatus(row.configId, row.status);
    proxy?.$modal.msgSuccess(text + '成功');
  } catch {
    row.status = row.status === '0' ? '1' : '0';
  }
};

onMounted(() => {
  getList();
});
</script>
<style scoped>
.action-buttons {
  display: flex;
  gap: 1px;

  .icon-btn {
    padding: 6px;
    height: 32px;
    border: 1px solid #dcdfe6;

    &:hover {
      border-color: var(--el-color-primary);
      color: var(--el-color-primary);
    }

    .el-icon {
      font-size: 14px;
    }
  }
}
</style>